(* Graduate Programming Languages - Wes Weimer 
 *
 * This is a driver file for the homework project. 
 *
 * Do not edit this file. 
 *)
open Printf

let main () = 
  let silent = ref false in 
  let args = [
    "--silent", Arg.Set silent, "do not display a prompt or reminder"
  ] in 
  Arg.parse args (fun _ -> ()) "" ; 

  if not !silent then begin 
    printf "Enter a string and an RE and end:\n" ;
    flush stdout ; 
  end ; 
  let lexbuf = Lexing.from_channel stdin in
  let str, re = Parse.program Lex.initial lexbuf in
  if not !silent then begin 
    print_endline (Re.re_to_str re) ; 
  end ; 
  let re_string = Re.string_to_re_string str in 
  let results = Hw3.matches re re_string in 
  if results = Re.emptyset then 
    print_endline "No Match" 
  else if results = Re.singleton [] then 
    print_endline "Matches Exactly" 
  else begin
    printf "Matches With Suffices:" ;
    Re.iter (fun elt -> 
      printf " \"%s\"" (Re.re_string_to_str elt) 
    ) results ; 
    print_endline "" ; 
  end ; 
  exit 0 
;;
main () ;;
